/* Copyright 2009-2011 Hewlett-Packard Development Company, L.P. All rights reserved. */
enyo.kind({
	name: "MediaTypePicker",
	kind: enyo.ListSelector,
	label: "",
	
	itemsChanged: function() {
		var mediaTypeStrings = this.getMediaTypeStrings();
		var mediaTypes = this.items || [];
		this.items = [];
		for (var i=0; i<mediaTypes.length; i++)
		{
			var mediaType = mediaTypes[i];
			if (mediaTypeStrings[mediaType]) {
				this.items.push({caption: mediaTypeStrings[mediaType], value: mediaType});
			}
		}
		// Call base implementation to populate picker list
		this.inherited(arguments);
		// Select default media type
		this.setDefaultMediaType();
	},

	setDefaultMediaType: function() {
		if (this.items.length > 0) {
			this.setValue("Photo");
		}
	},
	
	getMediaTypeStrings: function() {
		return {
			"Plain": PrintDialogString.load("PLAIN"),
			"Photo": PrintDialogString.load("PHOTO"),
			"Transparency": PrintDialogString.load("TRANSPARENCY")
		};
	}
});
