enyo.kind({
	name: "ActiveChatCreateCase",
	kind: enyo.VFlexBox,
	events:{
		onLinkClick:"",
		onSelect:""
	},
	published:{
		nextAction:"",
		productNo:"",
		problem:"",
		serialNo:"",
		productDesc:"",
		productId:"",
		activeChatCaseId:""
	},
	components:[
			{kind:"WebService", name:"createCaseWebService", onSuccess:"createCaseSuccess",method: "POST", contentType: "application/json; charset=utf-8", handleAs: "json", onFailure:"createCaseFailure"},
			{kind: "RowGroup", defaultKind:"HFlexBox", caption:"Chat Support",name:"ProblemForm", components:[
			{name:"chatSupportText",className:"infoLabel", content:"Please describe your problem below to get real-time help from a support specialist."},
			{content:"", name:"productDescLabel", className:"infoTextHeader"},
			{kind:"Item", name:"InputContainer",flex:1,showing:true},
			//{layoutKind: "HFlexLayout", pack:"center", components: [{kind: "SpinnerLarge",name:"Spinner",showing:false}]},
		    {align: "center", pack:"center",  tapHighlight: false, components: 
			[{kind: "ToolButton", name:"submitButton", active:false, caption:"Submit", tapHighlight: false, onclick: "createActiveChatCase"}]}
			]},
			
			{content:"", flex:1},
			{kind: "HFlexBox", className: "enyo-row", components: [
				{kind: "ToolButton", name:"Back", icon: "images/menu-icon-back.png", onclick:"goBack"},
				{content:"", flex:1},
				{kind: "ToolButton",name: "Home",icon: "images/home.png",onclick: "goHome"}, 
			]},
			{kind: "Dialog", name:"ErrorDialog", components: [
					{className: "infoDialogHeader", name:"ErrorTitle", style: "padding: 12px", content: "Missing Problem Description"},
        			{className: "infoDialogText", style:"padding:12px", name:"ErrorMessage", content: "Please enter the problem description."},
        			{layoutKind: "HFlexLayout", pack:"center", components: [{kind: "Button",caption: "OK", onclick: "clickOK"},
         		]}]},
			{kind: "Scrim", layoutKind: "VFlexLayout", align: "center", pack: "center", components: [{kind: "SpinnerLarge",name:"Spinner",showing:true}]}
	],
	showKeyBoard:function()
	{
		showKeyBoard();
	},
	clickOK:function()
	{
		this.$.ErrorDialog.close();
	},
	goHome:function(inSender,inArg1)
	{
		this.doSelect(inSender.getName());		
	},
	goBack:function(inSender,inArg1)
	{
		this.doSelect("Back");	
	},
	create: function(){
		this.inherited(arguments);
		var thisHandle=this;
		productMatchList=[];
		var m = this.$.InputContainer;
		if(localStorage.deviceType=="iOS")
		{
			console.log("creating htmlContent");
			m.createComponent({ kind:"HtmlContent", name: "ProblemDesc", srcId:"chatProblemTextArea", flex:1, owner: this});
		}
		else
		{
			console.log("creating richtext");
			m.createComponent({kind: "RichText", name:"problemDesc", flex:1, hint:"Describe your problem", onclick:"showKeyBoard", className:"problemDesc", richContent:false,  flex:1,owner: this});
		}
		m.render();
	},	
    productDescChanged:function()
	{
		this.$.productDescLabel.setContent(this.getProductDesc());
	},	
	createActiveChatCase: function(inSender, inArg){
		hideKeyBoard();
		var problemDesc;
		if(localStorage.deviceType=="iOS")
		{
		  problemDesc = getChatProblemText();
		}
		else
		{
		  problemDesc = this.$.problemDesc.getValue();
		}
		this.setProblem(problemDesc);
		if(problemDesc==""||problemDesc==undefined)
		{
			 this.$.ErrorDialog.open();
			 return;	
		}
		
		this.$.scrim.show();
		var infoObj =new Object();
		infoObj.fname=localStorage.fname;
		infoObj.lname=localStorage.lname;
		infoObj.email=localStorage.email;
		infoObj.phone=localStorage.phone;
		infoObj.productNo=this.getProductNo();
		infoObj.serialNo=this.getSerialNo();
		infoObj.productName=this.getProductDesc();
		infoObj.problem=problemDesc;
		infoObj.countryCode="US";
		var url="http://" + SERVER_ADD+ "/CreateChatCase";
		this.$.createCaseWebService.setUrl(url);
		var parameters=enyo.json.stringify(infoObj);
		logthis(parameters);
		this.$.createCaseWebService.call(parameters);
	},
	createCaseSuccess:function(inSender,inResponse){
		this.$.scrim.hide();
		try {
			var obj = enyo.json.parse(inResponse.d);
		    logthis(inResponse.d);
			if (obj.srId == "-1") {
				this.doSelect("AsssistedSupportHome");
				return;
			}
			this.setActiveChatCaseId(obj.srId);
			this.saveCaseToDB();
		}catch(e){
			console.log("exception in createcasesuccess");
			this.doSelect("AssistedSupportHome");
			return;
		}
	},
	createCaseFailure:function(inSender,inResponse){
		this.$.scrim.hide();
		this.log("get products failed");
	},
	saveCaseToDB:function()
	{
		var caseId = this.getActiveChatCaseId();
		var problemDesc= this.getProblem();
		var productDesc= this.getProductDesc();
		var productNo= this.getProductNo();
		var serialNo= this.getSerialNo();
		
		var thisHandler = this;
		db.transaction(function(transaction){
					   transaction.executeSql('INSERT INTO ActiveChat (id,problem,productDesc,productNo,serialNo) VALUES (?, ?, ?, ?, ?);', [caseId, problemDesc,productDesc,productNo,serialNo], 
					   function(){
					   		thisHandler.doSelect("Chat");
					   		}, errorHandler);
		});
	}
	
});


