enyo.kind({
	name: "Chat",
	kind: enyo.VFlexBox,
	events:{
		onLinkClick:"",
		onSelect:""
	},
	published:{
		nextAction:"",
		problem:"",
		productNo:"",
		serialNo:"",
		productDesc:"",
		productId:"",
		activeChatCaseId:"",
		chatMsgCount:"",
		chatMsgList:"",
		pollForChatMsg:"",
		srClosed:false
	},
	components:[
			{kind:"WebService", name:"getChatWebService", onSuccess:"getChatSuccess", method: "POST", contentType: "application/json; charset=utf-8", handleAs: "json", onFailure:"getChatFailure"},
			{kind:"WebService", name:"sendChatWebService", onSuccess:"sendChatMessageSuccess",method: "POST", contentType: "application/json; charset=utf-8", handleAs: "json", onFailure:"sendChatMessageFailure"},
			{kind:"Header",content:"Active Chat", name:"headerTitle", className:"headerSmall"},
			{kind: "Scroller", name:"chatMsgScroller", flex:1,components: [
						{name: "chatList",
							kind: "VirtualRepeater",
							onSetupRow: "listGetItem",
							components: [{name: "item",kind: "Item",layoutKind: "HFlexLayout", onclick:"itemListClicked", components: [{name: "itemCaption", allowHtml:true, className:"productList",flex:1}]}]
						}
					
			]},
			{layoutKind: "HFlexLayout", style: "width:100%;", components: [
				{kind:"Item", name:"InputContainer",flex:1},
				{layoutKind: "VFlexLayout",align:"center", components: [{content:"",flex:1},{kind: "ActivityButton", name:"sendButton", active:false, caption:"Send", tapHighlight: false, onclick: "sendChatMessage"},{content:"",flex:1}]}
			]},
			{kind: "HFlexBox", className: "enyo-row", components: [
				{kind: "ToolButton", name:"Back", icon: "images/menu-icon-back.png", onclick:"goBack"},
				{content:"", flex:1},
				{kind: "ToolButton",name: "Home",icon: "images/home.png",onclick: "goHome"}, 
			]},
	],
	showKeyBoard:function()
	{
		showKeyBoard();
	},
	goHome:function(inSender,inArg1)
	{
		this.doSelect(inSender.getName());		
	},
	goBack:function(inSender,inArg1)
	{
		this.doSelect("Back");	
	},
	create: function(){
		this.inherited(arguments);
		var m = this.$.InputContainer;
		if(localStorage.deviceType=="iOS")
		{
			console.log("creating htmlContent");
			m.createComponent({ kind:"HtmlContent", name: "chatTextArea", srcId:"chatTextArea", flex:1, owner: this});
		}
		else
		{
			console.log("creating richtext");
			m.createComponent({kind: "RichText", name:"chatMsgBox", flex:1, hint:"type your message", onclick:"showKeyBoard",  className:"chatMsgBox", richContent:false,  flex:1,owner: this});
		}
		m.render();
	},
	pollForChatMsgChanged:function()
	{
	},
    activeChatCaseIdChanged:function()
	{
		this.setChatMsgCount(0);
		this.setChatMsgList("");
		//this.getChatFromDB();
		this.$.chatList.render();
		this.getChatMessage();
	},
		
	getChatMessage: function(){
		logthis("in getChatMessage");
		var url="http://" + SERVER_ADD+ "/GetChatMessage";
		var infoObj=new Object();
		infoObj.srId=this.getActiveChatCaseId();
		infoObj.count=this.getChatMsgCount();
		var parameters=  enyo.json.stringify(infoObj)
		this.$.getChatWebService.setUrl(url);
		logthis(parameters);
		this.$.getChatWebService.call(parameters);
		  
	},
	
	getChatSuccess:function(inSender,inResponse){
		try {
			this.$.sendButton.setActive(false);
			if (inResponse != null || inResponse != "") {
				logthis("inResponse=" + inResponse.d);
				var obj=enyo.json.parse(inResponse.d);
				if (obj.messages.length == this.getChatMsgCount()) return;
				this.setChatMsgList(obj);
				this.$.chatList.render();
				this.saveChatToDB();
			}
		}catch(e){//alert("in getChatSuccess:" + e);
		}
		if (this.getPollForChatMsg() == true) {
			enyo.job("CHATPOLL", enyo.bind(this, this.getChatMessage), 15000);
		}
    },
	getChatFailure:function(inSender,inResponse){
		this.$.sendButton.setActive(false);
		if (this.getPollForChatMsg() == true) {
			enyo.job("CHATPOLL", enyo.bind(this, this.getChatMessage), 15000);
		}
	},
	sendChatMessage:function(inSender,inResponse)
	{
		hideKeyBoard();
		var chatMsg;
		if(localStorage.deviceType=="iOS")
		{
		  chatMsg=getChatText();
		}
		else
		{
		  chatMsg=this.$.chatMsgBox.getValue();
		}		
		if(chatMsg=="")return;
		var url=""
		url="http://" + SERVER_ADD+ "/SendChatMessage";
		var infoObj =new Object();
		infoObj.text=chatMsg;
		infoObj.srId=this.getActiveChatCaseId();
		var parameters= enyo.json.stringify(infoObj);
		this.$.sendButton.setActive(true);
		this.$.sendChatWebService.setUrl(url);
		this.$.sendChatWebService.call(parameters);
		if(localStorage.deviceType!="iOS")this.$.chatMsgBox.setValue("");
		logthis("message sent");
	},
	sendChatMessageSuccess:function(inSender,inResponse)
	{
	},
	sendChatMessageFailure:function(inSender,inResponse)
	{
		this.$.sendButton.setActive(false);
	},
	listGetItem:function(inSender,inIndex)
	{
		try {
			var data = this.getChatMsgList();
		    if(inIndex==0)
			{
				message="<b>Me:</b>"+ this.getProblem();
				this.$.itemCaption.setContent(message);
				this.$.chatMsgScroller.scrollToBottom();
				return true;
			}
			if (data == undefined||data=="") return;
			inIndex=inIndex-1;
			if (inIndex >= 0 && inIndex < data.messages.length) {
				var dataItem = data.messages[inIndex];
				var message = dataItem.message;
		        logthis(message);
				message=unescape(message.replace(/\+/g, " "));
				this.$.itemCaption.setContent(message);
				this.$.chatMsgScroller.scrollToBottom();
				return true;
			}
			//if(inIndex==data.messages.length)
			//{
			//	this.$.itemCaption.setContent("");
			//	this.$.chatMsgScroller.scrollToBottom();
			//	return true;
			//}
			return false;
		} 
		catch (e){alert(e.description)}
	},
	getChatFromDB:function()
	{
		try {
			var chatMsg = this.getChatMsgList();
			var srId = this.getActiveChatCaseId();
			var thisHandler = this;
			db.transaction(function(transaction){
				transaction.executeSql('select chatText from ActiveChat  where id=' + srId + ';', [], 
				function(transaction, result){
					if (result == undefined || result.rows.length == 0) {
						console.log("no chat message in db!")
					}
					else {
						var r = result.rows.item(0);
						//var chatObj= enyo.json.parse(r.chatText);
						console.log(enyo.json.stringify(chatObj));
						//thisHandler.setChatMsgList(r.chatText);
						//thisHandler.$.chatList.render();
					}
				}
				, errorHandler);
			});
		}catch(e){}	
	},
	saveChatToDB:function()
	{
		try {
			var chatMsgObj = this.getChatMsgList();
			var srId = this.getActiveChatCaseId();
			db.transaction(function(transaction){
				transaction.executeSql('update ActiveChat set chatText=\"' + chatMsgObj + '\" where id=' + srId + ';', [], function(){
				}, errorHandlerChatSave);
			});
		}catch(e){}
	}
	
});

function errorHandlerChatSave()
{
	console.log("Error while saving");
}
