enyo.kind({
	name: "CheckWarranty",
	kind: enyo.VFlexBox,
	events:{
		onLinkClick:"",
		onSelect:""
	},
	published:{
		nextAction:"",
		productNo:"",
		serialNo:"",
		productDesc:"",
		productId:"",
		chatEnabled:"True"
	},
	RetryCount:0,
	components:[
			{kind:"WebService", name:"getWarrantyStatus", onSuccess:"gotWarrantyStatus",  method: "POST", contentType: "application/json; charset=utf-8", handleAs: "json", onFailure:"getWarrantyFailure"},
		 	//{kind: "Scroller", flex: 1, components: [
				{kind: "RowGroup", defaultKind:"HFlexBox", caption:"Check Warranty", components:[
				{name:"productDescLabel", className:"infoLabel"},
				{kind: "RoundedInput", name:"SerialNumber", onclick:"showKeyBoard", className:"inputFieldClass", hint: "Enter Serial No"},
				{align: "center", pack:"center",  tapHighlight: false, components: 
				[{kind: "ToolButton", name:"submitButton", active:false, caption:"Submit", tapHighlight: false, onclick: "checkWarranty"}]}
				]},
			{kind: "Scroller", flex: 1, components: [
				{kind: "RowGroup", defaultKind:"HFlexBox", caption:"info", components:[
				{content:"Serial number is required to check for warranty. Assisted support is available only for products that are under warranty or have an active support contract.", className:"infoText"}
				]},
			]},
			{kind: "HFlexBox", className: "enyo-row", components: [
				{kind: "ToolButton", name:"Back", icon: "images/menu-icon-back.png", onclick:"goBack"},
				{content:"", flex:1},
				{kind: "ToolButton",name: "Home",icon: "images/home.png",onclick: "goHome"}, 
			]},
			{kind: "Scrim", layoutKind: "VFlexLayout", align: "center", pack: "center", components: [{kind: "SpinnerLarge",name:"Spinner",showing:true}	]},
			{kind: "Dialog", name:"ErrorDialog", components: [
				{className: "infoDialogHeader", style:"padding:12px", content: "Warranty Check Failed!"},
				{className: "infoDialogText", style:"padding:12px", name:"ErrorDesc", content: "Your product is out of warranty or does not have an active support contract. Assisted Support is available for products only during their warranty, HP Care Pack or support agreement period."},
        		{layoutKind: "HFlexLayout", pack:"center", components: [
            		{kind: "Button",caption: "OK", onclick: "clickOK"},
           		]}
    		]},
			
	],
	showKeyBoard:function()
	{
		showKeyBoard();
	},
	clickOK:function()
	{
		this.$.ErrorDialog.close();
	},
	goHome:function(inSender,inArg1)
	{
		this.doSelect(inSender.getName());		
	},
	goBack:function(inSender,inArg1)
	{
		this.doSelect("Back");	
	},
	create: function(){
		this.inherited(arguments);
		var thisHandle=this;
		productMatchList=[];
	},
	productDescChanged:function()
	{
		this.$.productDescLabel.setContent(this.getProductDesc());
		this.$.SerialNumber.setValue(this.getSerialNo());
	},
	checkWarranty: function(inSender, inArg){
		hideKeyBoard();
		this.$.scrim.show();
		if(this.$.SerialNumber.getValue()=="")
		{
			this.$.scrim.hide();
			return;
		}
		try {
			var infoObj = new Object(); 	
			infoObj.serialNo = this.$.SerialNumber.getValue();
			infoObj.productNo= this.getProductNo();
			infoObj.productName=this.getProductDesc();
			infoObj.countryCode="US";
			var url = "http://" + SERVER_ADD + "/CheckWarranty";
			this.$.getWarrantyStatus.setUrl(url);
			var parameters = enyo.json.stringify(infoObj);
			this.$.getWarrantyStatus.call(parameters);
		}catch(e){
			this.$.scrim.hide();
		}
	},
	gotWarrantyStatus:function(inSender,inResponse){
		this.$.scrim.hide();
		try {
			console.log(inResponse.d);
			var obj = enyo.json.parse(inResponse.d);
			if (obj.WarrantyStatus == "TRUE" || obj.ContractActive == "TRUE" || obj.Status == "FALSE") {
				this.setChatEnabled(obj.ChatEnabled);
				this.setSerialNo(this.$.SerialNumber.getValue());
				this.saveSerialNoToDB();
			}
			else {
				console.log("warranty not fond");
				this.$.ErrorDialog.open();
			}
		}catch(e){
			console.log("Error in CheckWarranty Response. Retry Count="+ this.RetryCount + "  Response=" + inResponse);
			if(this.RetryCount<=2) this.checkWarranty();
			this.RetryCount = this.RetryCount + 1;
		}
	},
	getWarrantyFailure:function(inSender,inResponse){
		this.$.scrim.hide();
		console.log("Failed CheckWarranty");
	},
	saveSerialNoToDB:function()
	{
		try {
			var id = this.getProductId();
			var serialNo = this.$.SerialNumber.getValue();
			this.setSerialNo(serialNo);
			var thisHandler=this;
			db.transaction(function(transaction){
				transaction.executeSql('update Devices set serialNo=\"' + serialNo + '\" where id=' + id + ';', [], function(){
					thisHandler.doSelect("AssistedSupportHome");
				}, errorHandler);
			});
		}catch(e){}
	}
});

