enyo.kind({
	name: "KMArticleList",
	kind: enyo.VFlexBox,
	events:{
		onLinkClick:"",
		onSelect:""
	},		
	published:{
		articleList:"",
		selectedCatId:"",
		productNo:"",
		selectedArticleUrl:"",
		selectedArticleTitle:"",
		assistedSolveLink:""
		
	},
	RetryCount:0,
	components:[
				{kind:"WebService", name:"getKMData", onSuccess:"gotKMData", onFailure:"getKMDataFailure",method: "POST", contentType: "application/json; charset=utf-8", handleAs: "json",},		
				{kind:"Item", name:"titleHeader", layoutKind:"HFlexLayout", align:"center", pack:"middle", domStyles:"height:30px", components: [
					{content:"", name:"catIcon",allowHtml:true, domStyles:"height:30px"},
					{content: "", name:"articleListName", flex: 1, className:"infoLabel", style:"padding-left: 10px"}
				]},
				//{kind:"Header", name:"articleListName", content:"Article List",className:"headerSmall"},
				{layoutKind: "HFlexLayout", pack:"center",  components: [{kind: "SpinnerLarge",name:"Spinner",showing:false}]},
				{kind: "Scroller", flex:1, components: [
					{name: "list",
							kind: "VirtualRepeater",
							onSetupRow:  "listGetItem",
							components: [{name: "item",kind: "Item",layoutKind: "HFlexLayout", components: [{name: "itemCaption", className:"productList",flex:1},{content: '<img src="images/right_arrow.png" width="28" height="28"/>',onclick:"itemListClicked"}]}]
					}
				
				]},
				{kind: "HFlexBox", className: "enyo-row", components: [
					{kind: "ToolButton", name:"Back", icon: "images/menu-icon-back.png", onclick:"goBack"},
					{content:"",flex:1},
					//{kind: "ToolButton", name:"assistedSolveButton", caption:"Assisted Solve", onclick:"gotoAssistedSolve"},
					{content:"",flex:1},
					{kind: "ToolButton",name: "Home",icon: "images/home.png",onclick: "goHome"}, 
				]},
				
	],
	goBack:function(inSender,inArg1)
	{
		this.doSelect("Back");	
	},
	goHome:function(inSender,inArg1)
	{
		this.doSelect(inSender.getName());		
	},
	gotoAssistedSolve:function(){
		this.doSelect(this.getAssistedSolveLink());
	},
	create: function(){
		this.inherited(arguments);
		this.setArticleList("");
	},
	setListHeader:function(arg)
	{
		this.$.articleListName.setContent(arg);
		this.$.catIcon.setContent(getCategoryImage(arg));
	},
	getKMDataForProduct: function(){
		this.setArticleList(null);
		this.$.list.render();
		this.$.Spinner.setShowing(true);
		var infoObj = new Object();
		infoObj.pNo = this.getProductNo();
		infoObj.rtype="1";
		infoObj.catId=this.getSelectedCatId();
		var parameters = enyo.json.stringify(infoObj);
    	var url = "http://" + SERVER_ADD +"/GetKMData"
        this.$.getKMData.setUrl(url);
		this.$.getKMData.call(parameters);
	},
	gotKMData:function(inSender,inResponse){
		this.$.Spinner.setShowing(false);
		try {
			var obj = enyo.json.parse(inResponse.d);
			this.setArticleList(obj);
			this.$.list.render();
		}catch(e){
			if(this.RetryCount<=2)
			{
				console.log("KM Data Error. RetryCount="+ this.RetryCount + "  Response=" + inResponse);
				if(this.RetryCount<=2) this.getKMDataForProduct();
				this.RetryCount = this.RetryCount + 1;
			}	
		}
	},
	getKMDataFailure:function(inSender,inResponse){
		this.$.Spinner.setShowing(false);
		alert("get products failed");
		//this.doSelect("Back");
	},
	refreshList:function(){
		this.$.list.render();
	},
	listGetItem:function(inSender,inIndex)
	{
		try {
			var data = this.getArticleList();
			if (data == undefined || data == ""||data==null) 
				return;
			if (inIndex >= 0 && inIndex < data.Articles.length) {
				this.$.itemCaption.setContent(data.Articles[inIndex].title);
				return true;
			}
		}catch(e){}
	},
	itemListClicked:function(inSender,inEvent)
	{
		var data = this.getArticleList();
		var dataItem = data.Articles[inEvent.rowIndex];
		var url= dataItem.uri;
		this.setSelectedArticleUrl(url);
		this.setSelectedArticleTitle(dataItem.title);
		this.doSelect("ViewArticle");
	}
});
