enyo.kind({
	name: "KMArticleView",
	kind: enyo.VFlexBox,
	events:{
		onLinkClick:"",
		onSelect:""
	},
	published:{
		url:"",
		docTitle:"",
		listHeader:""
	},
	components:[
		{kind: "WebService", name: "EmailService", onSuccess: "emailSuccess", method: "POST", contentType: "application/json; charset=utf-8", handleAs: "json", onFailure: "emailFailure" },
		{kind : "enyo.PalmService", name : "OpenFileReq",service : "palm://com.palm.applicationManager/",method : 'open',onSuccess : "openSuccess",onFailure : "openFailure"},
		{kind:"Scroller",  flex:1, components:[
			{kind:"Item", name:"WebViewContainer", flex:1, showing:false},
				
			{kind:"RowGroup", name:"ArticleTitleContainer", caption:"", showing:false, components:[
					{content:"",name:"ArticleTitle",className:"infoLabel",flex:1},
			
					{content:"<img src='images/1x1_clear.gif' height=20px'/>"}, 																																											
					{content:"Click View to open the document.",className:"infoText",flex:1},
					{content:"Click Email to email the document link.",className:"infoText",flex:1},
					{content:"Click Tag to save the document link.",className:"infoText",flex:1},
			]},
		]},
	    {kind: "HFlexBox", className: "enyo-row", components: [
			{kind: "ToolButton", name:"Back", icon: "images/menu-icon-back.png", onclick:"goBack"},
			{content:"",flex:1, name:"ViewSpacer", showing:false},
			{kind: "ToolButton", name:"ViewButton", caption:"View", onclick:"openChildBrowser",showing:false },
			{content:"",flex:1},
			{kind: "ToolButton", name:"Email", caption:"Email", onclick:"emailUrl"},
			{content:"",flex:1},
			{kind: "ToolButton",name: "Tag", caption:"Tag", onclick: "tagUrl"}, 
			{content:"",flex:1},
			{kind: "ToolButton",name: "Home",icon: "images/home.png",onclick: "goHome"}, 
		]},	
		{kind: "Dialog", name:"tagDialog", components: [
			{className: "infoDialogHeader", style: "padding:12px", content: "Tag Document"},
        	{className: "infoDialogText", style: "padding:12px", content: "Document has been tagged. You can now retrieve this document from the Service History option in the home screen."},
        	{layoutKind: "HFlexLayout", pack:"center", components: [
            	{kind: "Button", name:"tagDialogOK", caption: "OK", onclick: "clickOK"},
           	]},
			{layoutKind: "HFlexLayout", pack:"center", components: [
							{kind:"Item", content:"<img src='images/1x1_clear.gif' height='40px'/>",flex:1}
			]}
    	]},
		{kind:"Dialog", name:"emailDialog", components: [
			{className: "infoDialogHeader", style: "padding:12px", name:"emailDialogTitle", content: "Email"},
			{className:"infoDialogText", style: "padding:12px", content: "Enter the email address below separated by commas."},
			{className: "enyo-item", components: [
				{kind: "RoundedInput", name:"emailAddress", onclick:"showKeyBoard", hint: "enter email address", content:""},
			]},
			{layoutKind: "HFlexLayout", pack:"center", components: [
				{content:"",flex:1},	
				{kind: "Button", caption: "Send", onclick:"sendEmail"},
				{content:"",flex:1},													
				{kind: "Button", caption: "Cancel", onclick:"cancelEmail"},
				{content:"",flex:1}	
			]},
			{layoutKind: "HFlexLayout", pack:"center", components: [
				{kind:"Item", content:"<img src='images/1x1_clear.gif' height='40px'/>",flex:1}
			]}
														 
		]},
		 { kind: "Scrim", layoutKind: "VFlexLayout", align: "center", pack: "center", components: [{ kind: "SpinnerLarge" }]}
	],
	showKeyBoard:function()
	{
		showKeyBoard();
	},
	cancelEmail:function(inSender,inArg)
	{
		this.$.emailDialog.close();	
	},
		  
	clickOK:function(inSender,inArgs)
	{
		this.$.tagDialog.close();
	},
	
	goBack:function(inSender,inArg1)
	{
		this.doSelect("Back");	
	},
		  
	goHome:function(inSender,inArg1)
	{
		this.doSelect(inSender.getName());		
	},
		  
	tagUrl:function(inSender,iArg1)
	{
		var url=this.getUrl();
		var title=this.getDocTitle();
		var thisHandle=this;
		db.transaction(function(transaction){
			transaction.executeSql('INSERT INTO TaggedArticles (url,title) VALUES (?, ?);', [url,title], function(){thisHandle.$.tagDialog.open();}, errorHandler);
		});
	},
		  
	emailUrl:function(inSender,inArg)
	{
		console.log(localStorage.email);
		this.$.emailDialog.open();
		this.$.emailAddress.setValue(localStorage.email);
	},
		  
	sendEmail:function(inSender,inArg)
	{
		
		try {
			var infoObj = new Object();
			infoObj.url = this.getUrl();
			infoObj.emailId = this.$.emailAddress.getValue();
			infoObj.title = this.getDocTitle();
			if(infoObj.emailId=="")
			{
				this.$.emailDialogTitle.setContent("Invalid Email Address");
				return;
			}
			var url = "http://" + SERVER_ADD + "/EmailArticle";
			this.$.EmailService.setUrl(url);
			var parameters = enyo.json.stringify(infoObj);
			this.$.emailDialog.close();
			this.$.scrim.show();
			this.$.EmailService.call(parameters);
		}catch(e){
			this.$.scrim.hide();
		}
	},
		  
	emailSuccess:function(inSender,inResponse)
	{
		//alert(inResponse.d);
		this.$.scrim.hide();
		
	},
		  
	emailFailure:function(inSender,inResponse)
	{
		this.$.scrim.hide();
	},
		  
	create: function(){
		this.inherited(arguments);
	},
		  
	openChildBrowser:function()
	{
		if (localStorage.deviceType == "WebOS") {
			//var str="{target:\""+this.getUrl()+"\"}";
			//console.log("calling open file req with " + str);
			//this.$.OpenFileReq.call(str);
			location.href=this.getUrl();
		}
		else {
			openChildBrowser(this.getUrl());
		}
	},
						 
	loadUrl:function()
	{
		var m = this.$.WebViewContainer;
		this.$.ViewSpacer.setShowing(false);
		this.$.ViewButton.setShowing(false);
		this.$.ArticleTitleContainer.setShowing(false);
	    this.$.ArticleTitle.setShowing(false);	
		if(localStorage.deviceType=="WebOS"||localStorage.deviceType=="PC")
		{
			if(this.$.ArticleView)
			{
				this.$.ArticleView.destroy();
			}	
			if (this.getUrl().indexOf(".pdf") != -1) {
				this.$.ViewSpacer.setShowing(true);
				this.$.ViewButton.setShowing(true);
		    	this.$.ArticleTitleContainer.setShowing(true);
				this.$.ArticleTitle.setShowing(true);	
		   		this.$.ArticleTitleContainer.setCaption(this.getListHeader());
				this.$.ArticleTitle.setContent(this.getDocTitle());
			}
			else{
				this.$.WebViewContainer.setShowing(true);
				m.createComponent({name: "ArticleView", kind:"WebView", className:"enyo-view", flex:1,owner: this});
				this.$.ArticleView.setUrl(this.getUrl());
				m.render();
			}
		}
		else
		{
		    this.$.ViewSpacer.setShowing(true);
			this.$.ViewButton.setShowing(true);
		    console.log(this.getDocTitle());
		    this.$.ArticleTitleContainer.setShowing(true);
			this.$.ArticleTitle.setShowing(true);	
		    this.$.ArticleTitleContainer.setCaption(this.getListHeader());
			this.$.ArticleTitle.setContent(this.getDocTitle());
			
		}		
	},
		 
	linkClicked:function(){}
});

