enyo.kind({
	name: "KMCategoryList",
	kind: enyo.VFlexBox,
	events:{
		onLinkClick:"",
		onSelect:""
	},		
	published:{
		productNo:"",
		categoryList:"",
		selectedEntry:"",
		selectedEntryDesc:"",
		headerTitle:"",
		headerText:"",
		assistedSolveLink:"",
		assistedSolveButtonCaption:"",
		checkContactInfo:false
	},
	RetryCount:0,
	components:[
	   			{kind:"WebService", name:"getKMData", onSuccess:"gotKMData", onFailure:"getKMDataFailure", method: "POST", contentType: "application/json; charset=utf-8", handleAs: "json",},		
				{kind:"Header",content:"Self Solve Category", name:"headerTitle", className:"headerSmall"},
				{name:"headerText", content: "Solutions to common problems for your product", className: "infoLabel", domStyles: {padding: "10px"} },
				{layoutKind: "HFlexLayout", pack:"center",  components: [{kind: "SpinnerLarge",name:"Spinner",showing:false}]},
				{kind: "Scroller", flex:1, components: [
					{name: "list",
							kind: "VirtualRepeater",
							onSetupRow:  "listGetItem",
							components: [{name: "item",kind: "Item",layoutKind: "HFlexLayout", onclick:"itemListClicked", components: [
							{content:"", allowHtml:true, name:"catIcon"},
							{content:"<img src='images/1x1_clear.gif' width=10px/>"},
							{name: "itemCaption", className:"productList",flex:1},{content: '<img src="images/arrow_1.png" width="20" height="20" class="enyo-roundy"/>'}
							]}]
					}
				
				]},
				{kind: "HFlexBox", className: "enyo-row", components: [
					{kind: "ToolButton", name:"Back", icon: "images/menu-icon-back.png", onclick:"goBack"},
					{content:"",flex:1},
					{kind: "ToolButton", name:"assistedSolveButton", caption:"Assisted Solve", onclick:"gotoAssistedSolve"},
					{content:"",flex:1},
					{kind: "ToolButton",name: "Home",icon: "images/home.png",onclick: "goHome"}, 
				]},
				{kind: "Dialog", name:"ErrorDialog", components: [
					{className: "infoDialogHeader", name:"ErrorTitle", style: "padding: 12px", content: "Missing Contact Info"},
        			{className: "infoDialogText", style:"padding:12px", name:"ErrorMessage", content: "Your contact information is required to get support. Please click OK to fill out the contact information."},
        			{layoutKind: "HFlexLayout", pack:"center", components: [{kind: "Button",caption: "OK", onclick: "goToUserInfo"},
         		]}]},
    ],
	goToUserInfo:function()
	{
		this.$.ErrorDialog.close();
		this.doSelect("NoUserInfo");
	},
	goBack:function(inSender,inArg1)
	{
		this.doSelect("Back");	
	},
	goHome:function(inSender,inArg1)
	{
		this.doSelect(inSender.getName());		
	},
	create: function(){
		this.inherited(arguments);
	},
	headerTitleChanged:function(){
		this.$.headerTitle.setContent(this.getHeaderTitle());
	},
	headerTextChanged:function(){
		this.$.headerText.setContent(this.getHeaderText());	
	},
	assistedSolveButtonCaptionChanged:function(){
		this.$.assistedSolveButton.setCaption(this.getAssistedSolveButtonCaption());
	},
	gotoAssistedSolve:function(){
		//if (this.getCheckContactInfo() == true) {
			if (localStorage.fname == undefined || localStorage.lname == undefined || localStorage.phone == undefined || localStorage.email == undefined) {
				this.$.ErrorDialog.open();
				return;
			}
		//}
		this.doSelect(this.getAssistedSolveLink());
	},
	getKMDataForProduct: function(){
		this.setCategoryList(null);
		this.$.list.render();
		this.$.Spinner.setShowing(true);
		var infoObj = new Object();
		infoObj.pNo = this.getProductNo();
		infoObj.rtype="0";
		infoObj.catId="0";
		var parameters = enyo.json.stringify(infoObj);
    	var url = "http://" + SERVER_ADD +"/GetKMData"
        this.$.getKMData.setUrl(url);
		this.$.getKMData.call(parameters);
		
	},
	gotKMData:function(inSender,inResponse){
		this.$.Spinner.setShowing(false);
		try {
			var obj = enyo.json.parse(inResponse.d);
			this.setCategoryList(obj);
			this.$.list.render();
		}catch(e){
			console.log("KM Data Error. RetryCount="+ this.RetryCount + "  Response=" + inResponse);
			if(this.RetryCount<=2) this.getKMDataForProduct();
			this.RetryCount = this.RetryCount + 1;
		}
	},
	getKMDataFailure:function(inSender,inResponse){
		this.$.Spinner.setShowing(false);
		console.log("get products failed");
		//this.doSelect("Back");
	},
	refreshList:function(){
		this.$.list.render();
	},
	listGetItem:function(inSender,inIndex)
	{
		try {
			var data = this.getCategoryList();
			if (data == undefined||data==null) 
				return false;
			if (inIndex >= 0 && inIndex < data.length) {
				var dataItem = data[inIndex];
				var title = dataItem.title;
				var imgSrc=getCategoryImage(title);
				this.$.catIcon.setContent(imgSrc);
				this.$.itemCaption.setContent(title);
				return true;
			}
		} 
		catch (e){}
	},
	itemListClicked: function(inSender, inEvent){
		var data = this.getCategoryList();
		var dataItem = data[inEvent.rowIndex];
		var id = dataItem.id;
		this.setSelectedEntry(id);
		this.setSelectedEntryDesc(dataItem.title);
		this.doSelect("ViewArticleList");
	}
});


function getCategoryImage(inArg)
{
		var img ="<img src='images/hotissues.png' width=25px height=25px/>";
		if(inArg.toLowerCase().indexOf("advisories")!=-1)img= "<img src='images/advisories.png' width=25px height=25px/>"
		if(inArg.toLowerCase().indexOf("replacement")!=-1)img= "<img src='images/parts.png' width=25px height=25px/>" ;
		if(inArg.toLowerCase().indexOf("manuals")!=-1) img="<img src='images/manuals.png' width=25px height=25px/>";
		if(inArg.toLowerCase().indexOf("top")!=-1) img="<img src='images/hotissues.png' width=25px height=25px/>";
		if(inArg.toLowerCase().indexOf("current")!=-1) img="<img src='images/hottopics.png' width=25px height=25px/>";
		//console.log(inArg + " - " + img);
		return img;
}
