enyo.kind({
	name: "PhoneSupportCreateCase",
	kind: enyo.VFlexBox,
	events:{
		onLinkClick:"",
		onSelect:""
	},
	published:{
		nextAction:"",
		productNo:"",
		serialNo:"",
		productDesc:"",
		productId:"",
		WCLCaseId:"",
		OPTCaseId:"",
		problem:"",
		count:0
	},
	components:[
			{kind:"WebService", name:"createCaseWebService", onSuccess:"createOPTCaseSuccess", method: "POST", contentType: "application/json; charset=utf-8", handleAs: "json", onFailure:"createCaseFailure"},
			{kind:"WebService", name:"getWCLCaseIdWebService", onSuccess:"getWCLSuccess", method: "POST", contentType: "application/json; charset=utf-8", handleAs: "json", onFailure:"createCaseFailure"},
			{kind: "RowGroup", defaultKind:"HFlexBox", caption:"Phone Support", showing:true, components:[
			{name:"phoneSupportText", className:"infoLabel", content:"Please describe your problem below to create a support ticket. This will help us resolve your issue faster over the phone when you talk to a support agent."},
			{content:"", name:"productDescLabel", className:"infoTextHeader"},
			{kind:"Item", name:"InputContainer",flex:1},
			{align: "center", pack:"center",  tapHighlight: false, components: 
			[{kind: "ToolButton", name:"submitButton", active:false, caption:"Submit", tapHighlight: false, onclick: "createPhoneSupportCase"}]}
			]},
			{content:"", flex:1},
			{kind: "HFlexBox", className: "enyo-row", components: [
				{kind: "ToolButton", name:"Back", icon: "images/menu-icon-back.png", onclick:"goBack"},
				{content:"", flex:1},
				{kind: "ToolButton",name: "Home",icon: "images/home.png",onclick: "goHome"}, 
			]},
			{kind: "Dialog", name:"ErrorDialog", components: [
					{className: "infoDialogHeader", name:"ErrorTitle", style: "padding: 12px", content: "Missing Problem Description"},
        			{className: "infoDialogText", style:"padding:12px", name:"ErrorMessage", content: "Please enter the problem description."},
        			{layoutKind: "HFlexLayout", pack:"center", components: [{kind: "Button",caption: "OK", onclick: "clickOK"},
         	]}]},
			{kind: "Scrim", layoutKind: "VFlexLayout", align: "center", pack: "center", components: [{kind: "SpinnerLarge",name:"Spinner",showing:true}]}
	],
	showKeyBoard:function()
	{
		showKeyBoard();
	},
	clickOK:function()
	{
		this.$.ErrorDialog.close();
	},
	goHome:function(inSender,inArg1)
	{
		this.doSelect(inSender.getName());		
	},
	goBack:function(inSender,inArg1)
	{
		this.doSelect("Back");	
	},
	create: function(){
		this.inherited(arguments);
		var m = this.$.InputContainer;
		if(localStorage.deviceType=="iOS")
		{
			console.log("creating htmlContent");
			m.createComponent({ kind:"HtmlContent", name: "ProblemDesc", srcId:"phoneProblemTextArea", flex:1, owner: this});
		}
		else
		{
			console.log("creating richtext");
			m.createComponent({kind: "RichText", name:"problemDesc", flex:1, hint:"Describe your problem", onclick:"showKeyBoard", className:"problemDesc", richContent:false,  flex:1,owner: this});
		}
		m.render();
	},	
    productDescChanged:function()
	{
		this.$.productDescLabel.setContent(this.getProductDesc());
	},	
	createPhoneSupportCase: function(inSender, inArg){
		hideKeyBoard();
		var problemDesc;
		if(localStorage.deviceType=="iOS")
		{
		  problemDesc = getPhoneProblemText();
		}
		else
		{
		  problemDesc = this.$.problemDesc.getValue();
		}
		if(problemDesc=="")
		{
			this.$.ErrorDialog.open();
			return;
		}
		this.setProblem(problemDesc);
		this.$.scrim.show();
		var infoObj =new Object();
		infoObj.fname=localStorage.fname;
		infoObj.lname=localStorage.lname;
		infoObj.phone=localStorage.phone;
		infoObj.countryCode="US";
		infoObj.email=localStorage.email;
		infoObj.productNo=this.getProductNo();
		infoObj.serialNo=this.getSerialNo();
		infoObj.productName=this.getProductDesc();
		infoObj.productLine="PQ";
		infoObj.problem=this.getProblem();
		var url="http://" + SERVER_ADD+ "/CreateOPTCase";
		this.$.createCaseWebService.setUrl(url);
		var parameters= enyo.json.stringify(infoObj);
		this.$.createCaseWebService.call(parameters);
	},
	createOPTCaseSuccess:function(inSender,inResponse){
		try {
			var obj = enyo.json.parse(inResponse.d);
			this.setOPTCaseId(obj.optId);
			this.retrieveWCLCaseId();
		}catch(e){
			console.log("exception in createOPTCaseSuccess. In Response="+ inResponse);
			this.$.scrim.hide();
		}
	},
	createCaseFailure:function(inSender,inResponse){
		this.$.scrim.hide();
	},
	retrieveWCLCaseId:function()
	{
		var srId=this.getOPTCaseId();
		var count=this.getCount();
		count=count+1;
		var url="http://" + SERVER_ADD+ "/GetGCSSCaseID";
		var infoObj = new Object();
		infoObj.caseId=srId;
		var parameters= enyo.json.stringify(infoObj);
		this.log("Getting WCL Case Id:"+ url);
		this.$.getWCLCaseIdWebService.setUrl(url);
		this.$.getWCLCaseIdWebService.call(parameters);	
		this.setCount(count);
	},
	getWCLSuccess:function(inSender,inResponse)
	{
		try {
			console.log(inResponse.d);
			if (inResponse.d == "0") {
				var count = this.getCount();
				this.log("COUNT=" + count);
				if (count < 5) {
					enyo.job("WCLCasePoll", enyo.bind(this, this.retrieveWCLCaseId), 5000);
				}
				else {
					this.log("WCL Case create failed");
					this.createCaseFailure(inSender, inResponse);
				}
			}
			if (inResponse.d > 0) {
				this.$.scrim.hide();
				this.setWCLCaseId(inResponse.d);
				this.saveCaseToDB();
			}
		}catch(e){
			console.log("exception in getWCLSuccess!");
			this.$.scrim.hide();
		}	
	},
	saveCaseToDB:function()
	{
		var caseId = this.getWCLCaseId().toString();
		var problem= this.getProblem();
		var productDesc= this.getProductDesc();
		var productNo= this.getProductNo();
		var serialNo= this.getSerialNo();
		var dt=new Date();
		var date = dt.toDateString();
		var thisHandler = this;
		
		db.transaction(function(transaction){                            
					   transaction.executeSql('INSERT INTO PhoneHistory (id,problem,productDesc,productNo,serialNo,date) VALUES (?, ?, ?, ?,?,?);', [caseId, problem,productDesc,productNo,serialNo,date], function(){
					   		thisHandler.doSelect("DisplayWCLCase");
					   		}, insertErrorHandler);
		});
	}
	
	
});


function insertErrorHandler()
{
	console.log("Duplicate case..");
}
