enyo.kind({
	name: "PhoneSupportHistory",
	kind: enyo.VFlexBox,
	events:{
		onLinkClick:"",
		onSelect:""
	},	
	published:{
		selectedCaseId:"",
		historyList:"",
		nextAction:""
	},	
	components:[
				{kind:"Header", content:"Phone Support History" ,className:"headerSmall"},
				{kind: "Scroller", flex:1, components: [
						{name: "list",
							kind: "VirtualRepeater",
							onSetupRow: "listGetItem",
							components: [
									{name: "item",kind: "Item",layoutKind: "VFlexLayout", components:[
										{kind: "Control", layoutKind: "HFlexLayout",components:[
											{kind: "Control", flex:1, layoutKind: "VFlexLayout", pack:"top",components:[
												{name: "problemCaption",className:"productList",allowHtml:true},
								 				{name: "productCaption",className:"productList",allowHtml:true},
								 				{name: "serialNoCaption",className:"productList",allowHtml:true},
								 				{name: "dateTimeCaption",className:"productList",allowHtml:true},
								 				{name: "caseIdCaption",className:"productList",allowHtml:true}
											]},
											{kind: "Control", layoutKind: "VFlexLayout", pack:"top",components:[
												{kind:"Button", name:"listButton",className: "enyo-button-negative", caption:"X", onclick:"deleteClicked"}
											]}
										]}
									]}
								
							]
						}
					
				]},
				{kind: "HFlexBox", className: "enyo-row", components: [
					{kind: "ToolButton",name: "Back",icon: "images/menu-icon-back.png",onclick: "goNav"}, 
					{content:"", flex:1},
					{kind: "ToolButton",name: "Home",icon: "images/home.png",onclick: "goNav"}, 
				]},
				{kind: "Dialog", name:"ErrorDialog", components: [
					{className: "infoDialogHeader", style:"padding:12px", content: "No records found"},
        			{className: "infoDialogText", style:"padding:12px",content: "There are no phone support history to display."},
        			{layoutKind: "HFlexLayout", pack:"center", components: [
            		{kind: "Button",caption: "OK", onclick: "clickOK"},
           			]}
    			]},
				
	],
	clickOK:function(inSender,inArg)
	{
		this.$.ErrorDialog.close();
		this.doSelect("Back");
	},
  
	goNav:function(inSender,inArg1)
	{
		this.doSelect(inSender.getName());		
	},
	create: function(){
		this.inherited(arguments);
	
	},
	updateHistoryList:function()
	{
		var thisHandler=this;
		db.transaction(function(transaction) {
			transaction.executeSql('SELECT * FROM PhoneHistory;',[], 
									function(transaction, result){
										if (result == undefined || result.rows.length == 0) {
											thisHandler.$.ErrorDialog.open();
										}
										else {
											thisHandler.setHistoryList(result);
											thisHandler.$.list.render();
										}
									}, 
							    	errorHandler
								  );
				   }
		 );

	},
		
	listGetItem:function(inSender,inIndex)
	{
		   var historyList = this.getHistoryList();
	       if(historyList==undefined) return;
		   try {
		   	if(historyList.rows.length==0)
			{
				return false;
			}
		   	if (inIndex >= 0 && inIndex < historyList.rows.length) {
		   		var r = historyList.rows.item(inIndex);
		   		if (r) {
					this.$.problemCaption.setContent(r.problem);
					this.$.problemCaption.setContent("<b>Product : </b>"+r.productDesc);
					this.$.serialNoCaption.setContent("<b>Serial No : </b>"+r.serialNo);
					this.$.dateTimeCaption.setContent("<b>Date : </b>"+r.date);
					this.$.caseIdCaption.setContent("<b>Case Id : </b>"+r.id);
		   			return true;
		   		}
		   	}
		   }catch(e){}
	},
	
	deleteClicked:function(inSender,inEvent)
	{
		var rowId=inEvent.rowIndex;
		var row = this.getHistoryList().rows.item(rowId);
		var id=row.id;
		var thisHandler=this;
		db.transaction(
			function(transaction) {
				transaction.executeSql('DELETE FROM PhoneHistory WHERE id=?;',[id],function(){
					thisHandler.updateHistoryList();
				}, errorHandler);
			}
		);
	}
});

