enyo.kind({
	name: "ProductMatchList",
	kind: enyo.VFlexBox,
	events:{
		onLinkClick:"",
		onSelect:""
	},	
	published:{
		autoSelectProduct:false,
		destination:"",
		selectedProductNo:"",
		selectedSerialNo:"",
		selectedProductDesc:"",
		selectedProductId:"",
	},
	components:[
				{kind:"Header",content:"Select Your Product",className:"headerSmall"},
				{kind: "Scroller",flex:1, components: [
					{name: "list",
							kind: "VirtualRepeater",
							onSetupRow: "listGetItem",
							components: [{name: "item",kind: "Item",layoutKind: "HFlexLayout", components: [{name: "itemCaption", className:"productList",flex:1},{kind:"Button", name:"listButton", className: "enyo-button-affirmative", caption:"+", onclick:"itemListClicked"}]}]
					}
				
				]},
				{kind: "Dialog", name:"ConfDialog", components: [
					{className: "infoDialogText", style: "padding: 12px", content: "Your product has been added. Click OK to continue."},
        			{layoutKind: "HFlexLayout", pack:"center", components: [{kind: "Button",caption: "OK", onclick: "clickOK"},
           		]}]},
				{kind: "HFlexBox", className: "enyo-row", components: [
					{kind: "ToolButton", name:"Back", icon: "images/menu-icon-back.png", onclick:"goBack"},
					{content:"", flex:1},
					{kind: "ToolButton",name: "Home",icon: "images/home.png",onclick: "goHome"}, 
				]},
    ],
	clickOK:function()
	{
		this.doSelect("Home");
	},
	goBack:function()
	{
		this.doSelect("Back");
	},
	goHome:function(inSender,inArg1)
	{
		this.doSelect(inSender.getName());		
	},
	create: function(){
		this.inherited(arguments);
		if(gProductMatchList.length==0) this.doSelect("RegisterProduct");
	},
	refreshList:function(){
		this.$.list.render();
		console.log("length="+ gProductMatchList.length)
	},
	listGetItem:function(inSender,inIndex)
	{
		var r=gProductMatchList[inIndex];
		if(r)
		{
			this.$.itemCaption.setContent(r.productName);
			return true;
		}
	},
	itemListClicked:function(inSender,inEvent)
	{
		var selectedProduct= gProductMatchList[inEvent.rowIndex];
		var pName=selectedProduct.productName;
		var pNo = selectedProduct.productNo;
		var sNo = gEnteredSerialNo;
		if (this.getAutoSelectProduct() == true) {
			this.setSelectedProductNo(pNo);
			this.setSelectedSerialNo(sNo);
			this.setSelectedProductDesc(pName);
			this.setSelectedProductId("");
		}
		var thisHandle=this;
		db.transaction(
				   function(transaction) {
				   	transaction.executeSql('INSERT INTO Devices (productNo,serialNo,productDesc) VALUES (?, ?, ?);', [pNo,sNo,pName],function(){thisHandle.dbInsertSuccess();},errorHandler);
				   }
		);
	},
	
	dbInsertSuccess:function()
	{
		if (this.getAutoSelectProduct() == true) {
			this.doSelect("UseAutoSelectedProduct");
		}
		else {
			var thisHandler = this;
			db.transaction(function(transaction) {
					transaction.executeSql('SELECT * FROM devices;',[],	function (transaction, result){	
							gRegisteredProductList=result;	
							thisHandler.$.ConfDialog.open();
						},errorHandler);
					}
			);	
		}
	}
	
});
