enyo.kind({
	name: "RegisterProduct",
	kind: enyo.VFlexBox,
	events:{
		onLinkClick:"",
		onSelect:""
	},
	published:{
		autoSelectProduct:false,
		destination:""
	},
	RetryCount:0,
	components:[
		    {kind:"WebService", name:"getProduct", onSuccess:"gotProducts", onFailure:"getProductsFailure",  method: "POST", contentType: "application/json; charset=utf-8"},
			//{kind: "Scroller", flex: 1, components: [
				{kind: "RowGroup", defaultKind:"HFlexBox", caption:"Enter Product Info", components:[
				{kind: "RoundedInput", name:"ProductName", className:"inputFieldClass", onclick:"showKeyBoard", hint: "Enter HP Product Name or Number"},
				{kind: "RoundedInput", name:"SerialNumber", className:"inputFieldClass",  onclick:"showKeyBoard",  hint: "Enter Serial No (Optional)"},
				{align: "center", pack:"center",  tapHighlight: false, components: 
				[{kind: "ToolButton", name:"submitButton", className:"buttonSmall", active:false, caption:"Submit", tapHighlight: true, onclick: "getProduct"}]}
				]},
			{kind: "Scroller", flex: 1, components: [
				{kind: "RowGroup", defaultKind:"HFlexBox", caption:"info", components:[
					{content:"Please enter the name of the HP product that you need help with. You can enter the product number or the product name such as HP Elitebook 8540w.", className:"infoText"}
				]},
				{kind: "Scrim", layoutKind: "VFlexLayout", align: "center", pack: "center", components: [
				{kind: "SpinnerLarge", name:"Spinner",showing:true}
				]},
			]},
			{kind: "HFlexBox", className: "enyo-row", components: [
				{kind: "ToolButton", name:"Back", icon: "images/menu-icon-back.png", onclick:"goBack"},
				{content:"", flex:1},
				{kind: "ToolButton",name: "Home",icon: "images/home.png",onclick: "goHome"}, 
			]},
			{kind: "Dialog", name:"ErrorDialog", components: [
			{className: "infoDialogHeader", style: "padding: 12px", content: "No Match Found"},
        	{className: "infoDialogText", style: "padding: 12px", content: "No matching products found. <br> Please enter the product name or the product number such as HP Elitebook 8540w or BU678US.<br> If your Product is a <b>HP Home and Home Office product</b> please refer to <a href='http://h10025.www1.hp.com/ewfrf/wc/siteHome?lc=en&cc=us&destPage=siteHome&='>HP Customer Care</a>"},
        	{layoutKind: "HFlexLayout", pack:"center", components: [
            	{kind: "Button",caption: "OK", onclick: "clickOK"},
           	]}
    	]},
			
	],
	showKeyBoard:function()
	{
		showKeyBoard();
	},
	clickOK:function(inSender,inArg)
	{
		this.$.ErrorDialog.close();
		this.$.scrim.hide();
	},
	goBack:function(inSender,inArg1)
	{
		this.doSelect("Back");	
	},
	goHome:function(inSender,inArg1)
	{
		this.doSelect(inSender.getName());		
	},
	create: function(){
		this.inherited(arguments);
		var thisHandle=this;
		productMatchList=[];
	},
	
	getProduct: function(inSender, inArg){
		hideKeyBoard();
		if(this.$.ProductName.getValue()=="")return;
		this.$.scrim.show();
		var infoObj = new Object();
        infoObj.pNo = this.$.ProductName.getValue();
		var parameters = enyo.json.stringify(infoObj);
    	var url = "http://" + SERVER_ADD +"/GetProductName"
		console.log(url + " " + parameters);
        this.$.getProduct.setUrl(url);
        //gProductMatchList=[];
		this.$.getProduct.call(parameters);
	},
	
	gotProducts:function(inSender,inResponse){
		this.$.scrim.hide();
		try {
			var obj = enyo.json.parse(inResponse.d);
			if (obj.length == 0) {
				this.$.ErrorDialog.open();
				return;
			}
			gProductMatchList = obj;
			gEnteredSerialNo = this.$.SerialNumber.getValue();
			this.doSelect("ProductMatchList");
		}catch(e){
			console.log("exception. product match response="+ inResponse);
			if(this.RetryCount<=2) this.getProduct();
			this.RetryCount=this.RetryCount + 1;
		}
	},
	getProductsFailure:function(inSender,inResponse){
		this.$.scrim.hide();
		console.log("get products failed" + inResponse);
	}
});

