enyo.kind({
	name: "TaggedDocumentHistory",
	kind: enyo.VFlexBox,
	events:{
		onLinkClick:"",
		onSelect:""
	},	
	published:{
		taggedDocList:"",
		selectedArticleUrl:"",
		selectedArticleTitle:"",
		selectedDocId:"",
		nextAction:""
	},	
	components:[
				{kind:"Header", content:"Tagged Documents" ,className:"headerSmall"},
				{kind: "Scroller", flex:1, components: [
						{name: "list",kind: "VirtualRepeater",onSetupRow: "listGetItem",components: [
							{name: "item",kind: "Item",layoutKind: "VFlexLayout", flex:1,components: [
								{kind: "Control", layoutKind: "HFlexLayout",components:[
									{name: "itemCaption", className:"productList",flex:1}
								]},
								{kind: "Control", layoutKind: "HFlexLayout", pack:"right",components:[
								    {content:"",flex:1},
									{kind:"Button",  pack:"right", caption:"View", onclick:"itemListClicked"},
									{kind:"Button",  pack:"right", className: "enyo-button-negative", caption:"X", onclick:"deleteClicked"},
								]}
							]}]
						}
					
				]},
				{kind: "HFlexBox", className: "enyo-row", components: [
					{kind: "ToolButton",name: "Back",icon: "images/menu-icon-back.png",onclick: "goNav"}, 
					{content:"", flex:1},
					{kind: "ToolButton",name: "Home",icon: "images/home.png",onclick: "goNav"}, 
				]},
				{kind: "Dialog", name:"ErrorDialog", components: [
					{className: "infoDialogHeader", style: "padding: 12px", content: "No records found"},
					{className: "infoDialogText", style:"padding:12px", content: "There are no tagged documents to display."},
        			{layoutKind: "HFlexLayout", pack:"center", components: [
            		{kind: "Button",caption: "OK", onclick: "clickOK"},
           			]}
    			]},
				
	],
	clickOK:function(inSender,inArg)
	{
		this.$.ErrorDialog.close();
		this.doSelect("Back");
	},
  
	goNav:function(inSender,inArg1)
	{
		this.doSelect(inSender.getName());		
	},
	create: function(){
		this.inherited(arguments);
	
	},
	updateDocumentList:function()
	{
		var thisHandler=this;
		db.transaction(function(transaction) {
			transaction.executeSql('SELECT * FROM TaggedArticles;',[], 
									function(transaction, result){
										if (result == undefined || result.rows.length == 0) {
											thisHandler.setTaggedDocList(result);
											thisHandler.$.ErrorDialog.open();
										}
										thisHandler.setTaggedDocList(result);
										thisHandler.$.list.render();
									}, 
							    	errorHandler
								  );
				   }
		 );

	},
		
	listGetItem:function(inSender,inIndex)
	{
		   var tagList = this.getTaggedDocList();
	       if(tagList==undefined) return;
		   try {
		   	if(tagList.rows.length==0)
			{
				return false;
			}
		   	if (inIndex >= 0 && inIndex < tagList.rows.length) {
		   		var r = tagList.rows.item(inIndex);
		   		if (r) {
		   			this.$.itemCaption.setContent(r.title);
		   			return true;
		   		}
		   	}
		   }catch(e){}
	},
	
	deleteClicked:function(inSender,inEvent)
	{
		var rowId=inEvent.rowIndex;
		var row = this.getTaggedDocList().rows.item(rowId);
		var id=row.id;
		var thisHandler=this;
		db.transaction(
			function(transaction) {
				transaction.executeSql('DELETE FROM TaggedArticles WHERE id=?;',[id],function(){
					thisHandler.updateDocumentList();
				}, errorHandler);
			}
		);
	},
	itemListClicked:function(inSender,inIndex)
	{	
		var tagList = this.getTaggedDocList();
	    var r = tagList.rows.item(inIndex.rowIndex);
		this.setSelectedArticleUrl(r.url);
		this.setSelectedArticleTitle(r.title);
	    this.setSelectedDocId(r.id);
		this.doSelect(this.getNextAction());
	}
});

